!freeRAM = $5E
!LockAnim = $9D
!LockAnim2 = $13FB
!YoshiTime = $18E8
!Layer1Direction = $55
!Layer2Direction = $56

!Layer1XPos = $1A
!Layer1XPosHi = $1B
!Layer1XPosNext = $1462
!LastScreenNumber = $5F

!PlayerXPosHi = $95
!PlayerXPosLo = $94
!MarioAnimation = $71
!IsHeDead = #$09

init:
	STZ $19
AllGood:
	RTL

main:
CheckScrolling:
	STZ $1411
	STZ $1413

	LDA !MarioAnimation
	CMP !IsHeDead
	BEQ AllGood

	LDA #$01
	STA $1B96

	LDA !freeRAM
	BPL MarioIsWhere
	
Camera:
	AND #$01
	ASL
	TAY
	JSR PanCamera
	RTL

MarioIsWhere:
	LDY #$00
	LDA !PlayerXPosHi
	BEQ SubScreen0
	BMI SubScreen0
SubScreen1:
	LDA !PlayerXPosLo
	CMP #$08
	BCS AllGood
	LDA #$80
	BRA GetitDone
SubScreen0:
	LDA !PlayerXPosLo
	CMP #$E8
	BCC AllGood
	LDA #$81
GetitDone:
	STA !freeRAM
	RTL

PanDirection:
	dw $FFF8,$0008
PlayerPush:
	dw $FFFF,$0001

PanCamera:
	REP #$20
	LDA !PlayerXPosLo
	CLC
	ADC PlayerPush,y
	STA !PlayerXPosLo

	LDA !Layer1XPos
	CLC
	ADC PanDirection,y
	STA !Layer1XPos
	STA !Layer1XPosNext
	
	BEQ Set0Done
	BMI Set0Done
	CMP #$0100
	BEQ Set1Done
	BPL Set1Done

	SEP #$20
	LDA #$01
	STA !LockAnim
	STA !LockAnim2
	RTS
Set0Done:
	LDA #$0000
	BRA DoneGoin
Set1Done:
	LDA #$0100
DoneGoin:
	STA !Layer1XPos
	STA !Layer1XPosNext
	SEP #$20
	STZ !LockAnim
	STZ !LockAnim2
	STZ !freeRAM
	RTS