!freeRAM = $5E
!LockAnim = $9D ;$13FD
!LockAnim2 = $13FB
!YoshiTime = $18E8
!Layer1Direction = $55
!Layer2Direction = $56

!Layer1XPos = $1A
!Layer1YPos = $1C
!Layer1YPosHi = $1D
!Layer1YPosN = $1464
!LastScreenNumber = $5F

!PlayerYPosHi = $97
!PlayerYPosLo = $96
!MarioAnimation = $71
!IsHeDead = #$09

DATA_UpdraftForce:
db $0E,$0C,$0A,$0A,$08,$08,$06,$06
db $00,$00,$08,$08,$10,$10,$12,$10

main:

LDA !PlayerYPosHi
CMP #$05
BNE Updraft
LDA !PlayerYPosLo
BPL Updraft
LDA #$01
STA $14AF

Updraft:
LDA $14AF
BEQ MegaCam	

	LDA $7D
	PHA
	LSR
	LSR
	LSR
	LSR
	TAX
	PLA

	SEC
	SBC DATA_UpdraftForce,x
	STA $7D

MegaCam:
CheckScrolling:
	LDA !MarioAnimation
	CMP !IsHeDead
	BEQ InstantReturn

	LDA !freeRAM
	BMI Scrollingham

NotScrolling:
	JSR CheckMario
InstantReturn:
	RTL

Scrollingham:
	ASL
	BMI ScrollingDown

ScrollingUp:
	REP #$20
	LDA !freeRAM-1
	AND #$3F00
	ORA #$0018
	CMP !Layer1YPos
	BCS DoneScrolling
	
	LDA !Layer1YPos
	SEC
	SBC #$0004
	STA !Layer1YPosN
	SEP #$20

	LDA #$01
	STA !LockAnim
	STA !LockAnim2
	STZ !Layer1Direction
	STZ !Layer2Direction
	RTL

ScrollingDown:
	REP #$20
	LDA !freeRAM-1
	AND #$3F00
	ORA #$0018
	CMP !Layer1YPos
	BCC DoneScrolling
	
	LDA !Layer1YPos
	CLC
	ADC #$0004
	STA !Layer1YPosN
	SEP #$20

	LDA #$01
	STA !LockAnim
	STA !LockAnim2
	INC
	STA !Layer1Direction
	STA !Layer2Direction
	RTL

DoneScrolling:
	LDA !freeRAM-1
	AND #$3F00
	ORA #$0018
	STA !Layer1YPosN

	SEP #$20
	STZ !LockAnim
	STZ !LockAnim2
	STZ !freeRAM
	RTL

CheckMario:
	LDA !PlayerYPosHi
	BMI SameScreen
	CMP !Layer1YPosHi
	BEQ SameScreen	
	CMP !LastScreenNumber
	BPL SameScreen

	LDA !PlayerYPosLo
	BPL BelowScreen
AboveScreen:
	LDA !Layer1YPosHi
	ORA #$80
	DEC
	STA !freeRAM

	RTS
BelowScreen:
	LDA !Layer1YPosHi
	ORA #$C0
	INC
	STA !freeRAM

SameScreen:
	RTS